cd('scripts/')
load('IntegratedResponsesFull.mat')
%% Create matrix for principal component analysis
fpca = [];cnt = 1;
for i =1:length(pcaF)
    fpca(cnt,:) = pcaF{i};
    cnt = cnt+1;
end
%% Remove glomeruli in position 7 (not assigned), position 15 (only present in 1 fly)
reUp = [];
glomsToInclude= [1:6,8:14,16];
for i = 0:16:length(fpca(1,:))-15
    temp = fpca(:,i+glomsToInclude);
    reUp(:,end+1:end+length(temp(1,:))) = temp;
end
fpca = reUp;
%% Replacing NaNs with mean values for flies imaged by Matt S
tfpca = fpca;
fpca = tfpca(1:34,:);
tempF = [];
gloms = nanmean(fpca);
for i = 1:length(fpca(:,1))
    temp = find(isnan(fpca(i,:)));
    tempF(i,:) = fpca(i,:);
    for k = temp
        tempF(i,k) = gloms(k);
    end
end
fpca = tempF;
%% Z-score by glomerulus for flies imaged by Matt S

pcaT = [];
glmLgth = length(glomsToInclude);
for i = 1:length(fpca)
    glomTemp2 = fpca(:,i);
    glomMean = nanmean(glomTemp2(:));
    glomStd = nanstd(glomTemp2(:));
    pcaT(:,i) = (glomTemp2-glomMean)./glomStd;
end
pc1 = pcaT;
%% Replacing NaNs with mean values for flies imaged by Matt C
fpca = tfpca(35:end,:);
tempF = [];
gloms = nanmean(fpca);
for i = 1:length(fpca(:,1))
    temp = find(isnan(fpca(i,:)));
    tempF(i,:) = fpca(i,:);
    for k = temp
        tempF(i,k) = gloms(k);
    end
end
fpca = tempF;
%% Z-score for flies imaged by Matt C
pcaT = [];
glmLgth = length(glomsToInclude);
for i = 1:length(fpca)
    glomTemp2 = fpca(:,i);
    glomMean = nanmean(glomTemp2(:));
    glomStd = nanstd(glomTemp2(:));
    pcaT(:,i) = (glomTemp2-glomMean)./glomStd;
end
fpca = pcaT;
fpca = [pc1;fpca];
%% Perform PCA on dataset: 
[coeff,score,latent,tsquared,explained,mu] = pca(fpca);
%% Swapp order to put flies from Fig 2 e-f (2-3) in positions 1,2,and 3
indS = [5,6,15,16,27,28];
tempStore = score(indS,:);
score(indS,:) = [];
score = [tempStore;score];
amwT = amw(indS);
amw(indS) = [];
amw = [amwT,amw];

%%
a1 = rand(length(score(:,1))/2,3);
figTime = figure;cnt = 1;a2 = {};ccT = 0;
for i = 1:2:length(score(:,1))
    c3 = 300;
    cnt = cnt+1;
    if amw(i)
        continue
    else
        ccT = ccT+1;
    end
    a2{i} = scatter(score(i,1),score(i,2));hold on;
    a2{i}.MarkerFaceColor = a1(ccT,:);
    a2{i}.MarkerEdgeColor = a1(ccT,:);
    a2{i}.MarkerFaceAlpha = 0.5;
    a2{i}.SizeData = c3;
%     if sum(i>=35)>0
%         a2{i}.MarkerEdgeColor = [0 0 0];
%         a2{i}.SizeData = 500;
%         a2{i}.LineWidth = 3;
%         a2{i}.Marker = 'v';
%     end
end
flyNames = {};
for i = 1:ccT
    flyNames{i} = strcat({'fly '},num2str(i));
    flyNames{i} = flyNames{i}{1};
    if sum(i > 10) > 0
    flyNames{i} = strcat({'fly '},num2str(i));
    flyNames{i} = flyNames{i}{1};
    end
end
aLeg = legend(flyNames);
aLeg.AutoUpdate = 'off';
aLeg.Box = 'off';
aLeg.FontSize = 8;

%%
ccT = 0;
for i = 2:2:length(score(:,1))   
    if amw(i)
        continue
    else
        ccT = ccT+1;
    end
    a7 = scatter(score(i,1),score(i,2));
    a7.MarkerFaceColor = a1(ccT,:);
    a7.MarkerEdgeColor = a1(ccT,:);
    a7.MarkerFaceAlpha = 0.5;
    a7.SizeData = c3;
    a3 = plot([score(i,1),score(i-1,1)],[score(i,2),score(i-1,2)]);
    a3.LineWidth = 2;a3.Color = a1(ccT,:);

%     if sum(i >= 35)>0
%         a7.MarkerEdgeColor = [0 0 0];
%         a7.SizeData = 500;
%         a7.LineWidth = 3;
%         a7.Marker = 'v';
% 
%     end
end
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PCA 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.25;
a = ylabel(strcat('PCA 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.25;

%%
benDistCalc_i_gen
